function AttSizeStreamLisner() {
};

AttSizeStreamLisner.prototype = {
    mBytesRead : null,
    mStream : null,
    
    QueryInterface : function(iid)  {
        if (iid.equals(Components.interfaces.nsIStreamListener) ||
            iid.equals(Components.interfaces.nsISupports))
         return this;

        throw Components.results.NS_NOINTERFACE;
        return 0;
    },

    onStartRequest : function (aRequest, aContext) {
        this.mStream = Components.classes['@mozilla.org/binaryinputstream;1'].createInstance(Components.interfaces.nsIBinaryInputStream);
    },
    
    onStopRequest : function (aRequest, aContext, aStatusCode) {
        var channel = aRequest.QueryInterface(Components.interfaces.nsIChannel);
        try {
            if (this.mMsgUri == GetDBView().URIForFirstSelectedMessage) {
                ABglobals.setAttSizeTextFor(this.mAttUrl,this.mBytesRead);
            }
        } catch (e) {}
        this.mStream = null;
    },
    
    onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {
        if (this.mMsgUri != GetDBView().URIForFirstSelectedMessage) {
            aRequest.cancel(Components.results.NS_BINDING_ABORTED);
            return;
        }
        this.mStream.setInputStream(aInputStream);
        var chunk = this.mStream.readByteArray(aCount);
        this.mBytesRead += aCount;
    }
}    

var ABglobals = {
    old_displayAttachmentsForExpandedView: null,

    init: function() {
        ABglobals.old_displayAttachmentsForExpandedView = document.defaultView.displayAttachmentsForExpandedView;
        document.defaultView.displayAttachmentsForExpandedView = ABglobals.new_displayAttachmentsForExpandedView;
    },

    new_displayAttachmentsForExpandedView: function() {
        ABglobals.old_displayAttachmentsForExpandedView();
        for (index in currentAttachments) {
            var attachment = currentAttachments[index];
            setTimeout(ABglobals.setAttSizeFor,1,attachment);
        }
    },
    
    setAttSizeFor: function(attachment) {
        var mms = messenger.messageServiceFromURI(attachment.uri).
            QueryInterface(Components.interfaces.nsIMsgMessageService);
        var streamLisner = new AttSizeStreamLisner(); 
        streamLisner.mAttUrl = attachment.url;
        streamLisner.mMsgUri = attachment.uri;
        mms.openAttachment(attachment.contentType,
            attachment.displayName,
            attachment.url, 
            attachment.uri, 
            streamLisner, 
            null, 
            null);
    },

    setAttSizeTextFor: function(attUrl, val) {
        var attachmentList = document.getElementById('attachmentList');
        for (var i = 0; i < attachmentList.childNodes.length; i++) {
            if (attachmentList.childNodes[i].attachment.url == attUrl) {
                var origlbl = attachmentList.childNodes[i].getAttribute("label");
                var siz = (val/1024).toFixed(2);
                var newlbl = origlbl + ' (' + siz + ' KiB)'
                attachmentList.childNodes[i].setAttribute("label", newlbl); 
                break;
            }
        }
    }
}
addEventListener("load", ABglobals.init, false);
