var ABglobals = {
    old_AddAttachment: null,
    old_RemoveSelectedAttachment: null,
    
    init: function() {
        var stff = AddAttachment;
        stff = stff.toString();
        if (stff.indexOf('ABglobals') == -1) {
            ABglobals.old_AddAttachment = document.defaultView.AddAttachment;
            document.defaultView.AddAttachment = ABglobals.new_AddAttachment;
        }
        var stff = RemoveSelectedAttachment;
        stff = stff.toString();
        if (stff.indexOf('ABglobals') == -1) {
            ABglobals.old_RemoveSelectedAttachment = document.defaultView.RemoveSelectedAttachment;
            document.defaultView.RemoveSelectedAttachment = ABglobals.new_RemoveSelectedAttachment
        }
        ABglobals.addSizes('',true); // this will populate the sizes for all attachments already there ( like on forwards. drafts and templates )
        var bucket = document.getElementById("attachmentBucket");
    },

    onBucketChange: function(event) {
        Components.classes["@mozilla.org/consoleservice;1"].
            getService(Components.interfaces.nsIConsoleService).
            logStringMessage('onBucketChange attr>' + event.attrName);
    },

    addSizes: function(attachment,noCheck) {
        var bucket = document.getElementById("attachmentBucket");
        var sizesIn = "KiB"
        var sizesBy = 1024
        try {
            sizesIn = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefBranch)
                .getCharPref("attsizes.sizesIn");
        } catch (e) {
            Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefBranch)
                .setCharPref("attsizes.sizesIn",sizesIn);
        }
        if (sizesIn == "kB") {
            sizesBy = 1000;
        }
        sizesIn = " " + sizesIn
        for (var i = 0; i < bucket.childNodes.length; i++) {
            var item = bucket.childNodes[i];
            if (noCheck) {
                attachment = item.attachment
            }
            if (item.attachment == attachment) {
                var extr = '';
                var siz = 0;
                try{
                    if (attachment.url.substring(0,7) == 'mailbox') {
                        var messenger = Components.classes['@mozilla.org/messenger;1'].createInstance();
                        messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
                        var msgHdr = messenger.messageServiceFromURI(attachment.url).messageURIToMsgHdr(attachment.url);
                        siz = (msgHdr.messageSize/sizesBy).toFixed(2);
                        extr = '(' + siz + sizesIn + ') '
                    } else {
                        // so get the file size here
                        var prothndlr = Components.classes["@mozilla.org/network/protocol;1?name=file"].createInstance(Components.interfaces.nsIFileProtocolHandler)
                        var fil = prothndlr.getFileFromURLSpec(attachment.url);
                        siz = (fil.fileSize/sizesBy).toFixed(2);
                        extr = '(' + siz + sizesIn + ') '
                        // then change the append item's label to include the size ...
                    }
                    item.attSize = siz
                    item.setAttribute('label',extr + item.getAttribute('label'));
                    ABglobals.attachmentRemoved();
                } catch(e) {
                    Components.classes["@mozilla.org/consoleservice;1"].
                        getService(Components.interfaces.nsIConsoleService).logStringMessage('err in attbytes e>' + e);

                }
            }
        }
    },

    attachmentRemoved: function() {
        var bucket = document.getElementById("attachmentBucket");
        var ttl = 0;
        for (var j=0; j < bucket.childNodes.length; j++) {
            ttl += parseFloat(bucket.childNodes[j].attSize)
        }
        var s = "";
        var totalWord = "";
        try {
            s = document.getElementById("attbytesBundle").getString('plural')
        } catch(e) {}
        try {
            totalWord = document.getElementById("attbytesBundle").getString('totalword')
        } catch(e) {}
        if (bucket.childNodes.length == 1) s = "";
        var tttext = bucket.childNodes.length + " Attachment" + s + ", " + ttl.toFixed(2) + " KiB " + totalWord;
        bucket.setAttribute('tooltiptext',tttext);
    },

    new_RemoveSelectedAttachment: function() {
        ABglobals.old_RemoveSelectedAttachment();
        ABglobals.attachmentRemoved();
    },
    
    new_AddAttachment: function(attachment) {
        ABglobals.old_AddAttachment(attachment);
        ABglobals.addSizes(attachment,false);
    }
}
addEventListener("load", ABglobals.init, false);
